Subject: Re: [PATCH 2/3] sit: handle ICMPv4 for tunnels with no remote

From: Patrick McHardy <[email-masked]>
Date: Mon, 08 Jun 2009 18:46:10 +0200

[email-masked] wrote:
> If iph.ttl == 0, it means that the ttl of the ipv4 package is inherited
> from the ipv6 package to be sent. In case the ipv4 ttl of the path
> expires, the ipv6 ttl would expire too. While the link does send a
> time_exceeded, I believe that the application should receive an ICMPv6
> time_exceeded as well, even if the package died right on the tunnel
> endpoint.

I have some patches that I wanted to post tommorrow, which will allow
to propagate errno values and queue congestion state of the underlying
device upwards from the hard_start_xmit() functions of virtual network
devices. With these patches, you can simply return -EHOSTUNREACH or
whatever is appropriate and it will be delivered to the application.

Would that help?